#include "stdafx.h"
#include "ComplForms.h"
#include "math.h"
extern HBITMAP hb;
extern bool hb_exist;
extern char szFileName[MAX_PATH];
extern int XSize;
extern int YSize;
extern BITMAPINFO* lpbi;
extern UCHAR* buf;


typedef struct tagMonitDeskr
{
	short Width;// 
	short Height;// 
	unsigned char Flags;/* 7: M = 1,      
						 4,5,6: cr+1 =    
						 3:  0  89 -        .
						 2,1,0: pixel+1 =  /   */
	UCHAR BackGround;//    
	UCHAR nol;//=0;
} MONITDESKR;// .

typedef struct tagImageDeskr
{
//      char id;             // ',' - - 
        unsigned short left;   //     
                             //     ( LSB)  
        unsigned short up;     //     
                             //    ( LSB)
        unsigned short width;  //     ( LSB)
        unsigned short height; //     ( LSB)
        UCHAR Flags;          //  7=0:    -
                             //          ,  'pixel'
                             //  7=1:     -
                             //          ,  'pixel'
                             //  6=0:    -
                             //           
                             //  6=1:    -
                             //            (Interleased)
                             //  3,4,5=0
                             //  0,1,2= +1      
							 // ( pixel)
} IMGDESKR;



struct tagRGBTriple
{
	UCHAR r,g,b;
};

//Global Variables
	unsigned long pos=0;//    
	long lc=0;//   
	UCHAR rbuf[260];//   .
	UCHAR BitInByte;
short GetCode(UCHAR CodeSize,unsigned long& CurBit)
{
	unsigned short t=CurBit/8,code;
		lc=rbuf[t]+rbuf[t+1]*256+rbuf[t+2]*65536;
		BitInByte=CurBit-t*8;//    
		lc>>=BitInByte;// long   ,   ( >10)    short,    7 
//		lc&=255;
		code=lc;
		code<<=16-CodeSize;
		code>>=16-CodeSize;//   .
		CurBit+=CodeSize;
		return code;
}
void OpenGIFfile(HWND hWnd)
{

//V	
	char Version[6];
	MONITDESKR MDeskr;
//^	
	FILE* f=fopen(szFileName,"rb");
	fread(Version,6,1,f);
	fread(&MDeskr,7,1,f);//sizeof(MONITDESKR)==8 - ,      ..   ,   ...
//V	
	UCHAR BitsPerPixel=(MDeskr.Flags&7) +1;
	tagRGBTriple* Palette;
	short NumColors=1<<BitsPerPixel;
//^	
	if(MDeskr.Flags&128)
	{
		//  
		Palette=new tagRGBTriple[NumColors];//
		fread(Palette,3,NumColors,f);
	}

	//   .    ','
	UCHAR rc=0;
	while((rc!=0x2C)&&(!feof(f)))
	{
		fread(&rc,1,1,f);
		if(rc==33)//   .   .
			while(rc)fread(&rc,1,1,f);//,    0 -   .
			// ,                   :)
	}
	if(feof(f))//  
	{
		fclose(f);
		delete[] Palette;
		return;
	}
	//     ,      , 
	//    fseek(f,-1,SEEK_CUR);       . 
	//         ,      :)
//V
	IMGDESKR ImgDeskr;// 
//^

	fread(&ImgDeskr,9,1,f);//sizeof(IMGDESKR)  :)  ,  ...
//V
	bool IsInterleased=ImgDeskr.Flags&64;//   ,   
	bool IsLocalPalette=ImgDeskr.Flags&128;//   
	short LocalBitsPerPixel=(ImgDeskr.Flags&7)+1;//       
	tagRGBTriple* LocalPalette;
	short LocalNumColors;
//^
	short AdoptedLineSize=((ImgDeskr.width+3)/4)*4;// ,     .       4.
	UCHAR CorrectionByte=AdoptedLineSize-ImgDeskr.width;//       ,  ,      4.
	short pp,wp;
//	short NumLines=0;//-   

	if(!IsLocalPalette)//   
	{
		LocalBitsPerPixel=BitsPerPixel;
		LocalPalette=Palette;
		LocalNumColors=NumColors;
	}
	else
	{
		LocalNumColors=1<<LocalBitsPerPixel;
		LocalPalette=new tagRGBTriple[LocalNumColors];
		fread(LocalPalette,3,LocalNumColors,f);//  .
	}
	//     ,   .
	/*     ,     255 . 
	         ,  
	    .       
	   .   ,       
	   (  0),      
	 .     
	   LZW (   ) */

	buf=new UCHAR[AdoptedLineSize*(ImgDeskr.height+2)];//        dWORD ,    BITMAP'a
	
	memset(buf,MDeskr.BackGround,AdoptedLineSize*ImgDeskr.height+2);
//V	
	UCHAR LZWCodeSize;// - ,   LZW    .          .
	UCHAR BlockSizeR=0;//     ,  <256,    
						//    - ,       .
	short BlockSize=0; //   ()

//^  
	fread(&LZWCodeSize,1,1,f);
//V
	short ClearCode=1<<LZWCodeSize;// 
	short EndCode=ClearCode+1;//  
//^
/*   = ClearCode+2   ClearCode   ,   , 
  ,    . 
	    LZWCodeSize==8   256 "" ( )   0..255 
	     .         
	  256,  256  257   .     .
	*/


	LPUCHAR* MassCep=new LPUCHAR[4097];//  .
	UCHAR* MassLen=new UCHAR[4097];//   
	
	unsigned long t,CepSize=0;//  
	signed short diff;
	UCHAR CodeSize=LZWCodeSize+1;
	unsigned short code,old;
	unsigned long CurBit=0;//CurBit -         
	int LinecepSize=60;// cep -  ,   .      MassCep
	UCHAR* cep=(UCHAR*)malloc(LinecepSize);//,  ,  ,      >60  
	
	bool OutFlag=false;// , ,       ,      .
	
	// .
	for(short i=0;i<ClearCode+2;i++)
	{
		MassCep[i]=new UCHAR[1];
		MassCep[i][0]=i;
		MassLen[i]=1;
	}
	memset(MassLen+ClearCode+1,0,4097-ClearCode-1);
	CepSize=ClearCode+2;
//         .
			fread(&BlockSizeR,1,1,f);//     .
			fread(rbuf,1,BlockSizeR,f);
			BlockSize=BlockSizeR;

			code=rbuf[0]+rbuf[1]*256;
			code<<=16-CodeSize;
			code>>=16-CodeSize;
			CurBit+=CodeSize;
			
			if(code==ClearCode)
			{
					for(short i=ClearCode+2;MassLen[i];i++)
					{
						delete[] MassCep[i];
						MassLen[i]=0;
					}
					CodeSize=LZWCodeSize+1;
					CepSize=ClearCode+2;

			code=GetCode(CodeSize,CurBit);
	
			}// ,    -     ClearCode

			
			buf[0]=MassCep[code][0];
			pos=1;
			old=code;

	while(1)
	{	

beg:		//  
		t=CurBit/8;
		if((diff=BlockSize-t)<4)//      ,   
		{
			if(!OutFlag)
			{
				if(feof(f))
					break;
				memmove(rbuf,rbuf+t,diff);
				memset(rbuf+diff,MDeskr.BackGround,260-diff);
				CurBit-=t*8;
				t=0;//t-BlockSize+4
				fread(&BlockSizeR,1,1,f);//     .
				if(!BlockSizeR)//   ,    
				{
					OutFlag=true;
				}
				else
				{
					BlockSizeR=fread(rbuf+diff,1,BlockSizeR,f);
					BlockSize=BlockSizeR+diff;//   BlockSize   
				}
			}
			else
			{
				//OutFlag=true.      ,      rbuf.       ,      ,   .
				if(diff<0)//diff==0
					break;
			}
			
		}
		/*
		lc=rbuf[t]+rbuf[t+1]*256+rbuf[t+2]*65536;
		BitInByte=CurBit-t*8;//    
		lc>>=BitInByte;// long   ,   ( >10)    short,    7 
		code=lc;
		code<<=16-CodeSize;
		code>>=16-CodeSize;//   .
		CurBit+=CodeSize;
		*/
		code=GetCode(CodeSize,CurBit);
		//

		// ,      
		if((code==ClearCode))
		{
					//
					for(short i=ClearCode+2;MassLen[i];i++)
					{
						delete[] MassCep[i];
						MassLen[i]=0;
					}
					CodeSize=LZWCodeSize+1;
					CepSize=ClearCode+2;

					/*
					t=CurBit/8;
					lc=rbuf[t]+rbuf[t+1]*256+rbuf[t+2]*65536;
					BitInByte=CurBit-t*8;//    
					lc>>=BitInByte;// long   ,   ( >10)    short,    7 
					code=lc;
					code<<=16-CodeSize;
					code>>=16-CodeSize;//   .
					CurBit+=CodeSize;
					*/
					code=GetCode(CodeSize,CurBit);
					//
					old=code;
					memset(cep,0,60);
					if(pos%AdoptedLineSize==ImgDeskr.width)pos+=CorrectionByte;// ,       ,      .

					buf[pos++]=MassCep[code][0];
					goto beg;
		}
		else
			if(code==EndCode) 
			{
				/*
			//	fseek(f,t+2-BlockSize,SEEK_CUR);
				
				do
				{
					fread(&rc,1,1,f);
					if(rc==33)//   .   .
						while(rc)fread(&rc,1,1,f);//,    0 -   .

				}while((rc!=0x2C)&&(!feof(f)));
			//	fread(&ImgDeskr,9,1,f);
				goto beg;
				*/
				break;
			}// ,   .
		
			
	// 
			{
			//      	
			if(MassLen[code])// code    
			{
				if(pos%AdoptedLineSize+MassLen[code]>ImgDeskr.width)/*     
						    ,       
						  ,       4,    .*/
				{
					pp=ImgDeskr.width-pos%AdoptedLineSize;//       
					memcpy(buf+pos,MassCep[code],pp);//
					pos+=pp+CorrectionByte;
					wp=0;//   ( -) 
					
					while(wp<(MassLen[code]-pp)/ImgDeskr.width)
					{
						memcpy(buf+pos,MassCep[code]+wp*ImgDeskr.width,ImgDeskr.width);//  
						pos+=ImgDeskr.width+CorrectionByte;
						++wp;
					}
					memcpy(buf+pos,MassCep[code]+pp+wp*ImgDeskr.width,t=MassLen[code]-wp*ImgDeskr.width-pp);
					pos+=t;


				}
				else
				{
					memcpy(buf+pos,MassCep[code],MassLen[code]);
					pos+=MassLen[code];
				}

				if(MassLen[old]>=LinecepSize)
				{
					LinecepSize=MassLen[old]+10;
					cep=(UCHAR*)realloc(cep,LinecepSize);

				}
				
				memcpy(cep,MassCep[old],MassLen[old]);
				cep[MassLen[old]]=MassCep[code][0];
				
				//   
				MassLen[CepSize]=MassLen[old]+1;
				MassCep[CepSize]=new UCHAR[MassLen[CepSize]];
				memcpy(MassCep[CepSize],cep,MassLen[CepSize]);


				
				CepSize++;
				old=code;
				if(CepSize==(1<<CodeSize))
				{
					++CodeSize;
					if(CodeSize==13) CodeSize=12;//  ,      12 .        ,       
				}
				/*
				   <code>   ;
            [...] <-   <old>;
            K <-     <code>;
             [...]K   ;
            <old> <- <code>;
      
				*/
				
			}
			else
			{
				if(MassLen[old]>=LinecepSize)
				{
					LinecepSize=MassLen[old]+10;
					cep=(UCHAR*)realloc(cep,LinecepSize);
				}

				memcpy(cep,MassCep[old],MassLen[old]);
				cep[MassLen[old]]=cep[0];
				
				//   .
				MassLen[CepSize]=MassLen[old]+1;
				MassCep[CepSize]=new UCHAR[MassLen[CepSize]];
				memcpy(MassCep[CepSize],cep,MassLen[CepSize]);
				

				//   
				if(pos%AdoptedLineSize+MassLen[CepSize]>ImgDeskr.width)/*     
						    ,       
						  ,       4,    .
						   ,    ,    ,  
							       */
				{
					pp=ImgDeskr.width-pos%AdoptedLineSize;
					memcpy(buf+pos,cep,pp);
					pos+=pp+CorrectionByte;
					wp=0;
					
					while(wp<(MassLen[CepSize]-pp)/ImgDeskr.width)
					{
						memcpy(buf+pos,cep+wp*ImgDeskr.width,ImgDeskr.width);//  
						pos+=ImgDeskr.width+CorrectionByte;
						++wp;
					}
					memcpy(buf+pos,cep+pp+wp*ImgDeskr.width,t=MassLen[CepSize]-wp*ImgDeskr.width-pp);
					pos+=t;
/*
					pos+=MassLen[CepSize]-pp+CorrectionByte;
					memcpy(buf+pos,cep+MassLen[CepSize]-pp,pp);
					pos+=pp;
*/
				}
				else//       .
				{
					
					memcpy(buf+pos,cep,MassLen[CepSize]);
					pos+=MassLen[CepSize];
				}
				
				CepSize++;
				old=code;
				if(CepSize==(1<<CodeSize))
				{
					++CodeSize;
					if(CodeSize==13) CodeSize=12;
				}
					/*
					[...] <-   <old>;
					K <-   [...];
					 [...]K       
                           ;
					<old> <- <code>
					*/

			}


			}//else

	}//while(1)

	fclose(f);
	for(i=0;MassLen[i];i++)
					{
						delete[] MassCep[i];
						MassLen[i]=0;
					}
	delete[] MassLen;
	delete[] MassCep;
	free(cep);
	//      (Interleased)    
	if(IsInterleased)
	{
		UCHAR *newbuf=new UCHAR[AdoptedLineSize*ImgDeskr.height+2];
		// 
		int NumP1=ImgDeskr.height/8+1;//-   
		int NumP2=NumP1-(ImgDeskr.height%8<5);//-   , (   ).
		int NumP3=ImgDeskr.height/4+1-(ImgDeskr.height%4<3);//-    ( 4   3 ).
		int NumP4=ImgDeskr.height/2;//-    ( 2 -   2 ).
		
		int i=0;
		for(;i<NumP1;i++)
		{
			memmove(newbuf+i*8*AdoptedLineSize,buf+i*AdoptedLineSize,AdoptedLineSize);//         
		}
		for(i=0;i< NumP2;i++)
		{
			memmove(newbuf+(i*8+4)*AdoptedLineSize,buf+(i+NumP1)*AdoptedLineSize,AdoptedLineSize);//         
		}
		for(i=0;i< NumP3;i++)
		{
			memmove(newbuf+(i*4+2)*AdoptedLineSize,buf+(i+NumP1+NumP2)*AdoptedLineSize,AdoptedLineSize);//         
		}
		for(i=0;i< NumP4;i++)
		{
			memmove(newbuf+(i*2+1)*AdoptedLineSize,buf+(i+NumP1+NumP2+NumP3)*AdoptedLineSize,AdoptedLineSize);//         
		}
		delete[] buf;
		buf=newbuf;
	}
	//  .


	if(hb_exist)
	{
		LocalFree(lpbi);
		DeleteObject(hb);
	}
	lpbi=(BITMAPINFO*)LocalAlloc(LPTR,sizeof(BITMAPINFOHEADER)+sizeof(RGBQUAD)*256);//*256   *LocalNumColors,      .
			//    bmp    .  bmp     256 ,      256 , 
			//      256  (   -    ).         256 .
	for(i=0;i<LocalNumColors;i++)
		{
			lpbi->bmiColors[i].rgbRed=LocalPalette[i].r;
			lpbi->bmiColors[i].rgbGreen=LocalPalette[i].g;
			lpbi->bmiColors[i].rgbBlue=LocalPalette[i].b;
			lpbi->bmiColors[i].rgbReserved=0;
		}
	
	/////////
	XSize=ImgDeskr.width;
	YSize=ImgDeskr.height;
	/////////
	lpbi->bmiHeader.biBitCount=8;//LocalBitsPerPixel;//   256  .       .
	lpbi->bmiHeader.biClrImportant=0;//1<<LocalBitsPerPixel;
	lpbi->bmiHeader.biClrUsed=0;//1<<LocalBitsPerPixel;
	lpbi->bmiHeader.biCompression=BI_RGB;
	lpbi->bmiHeader.biHeight=-YSize;
	lpbi->bmiHeader.biPlanes=1;
	lpbi->bmiHeader.biSize=40;//sizeof(BITMAPINFOHEADER)
	lpbi->bmiHeader.biSizeImage=0;
	lpbi->bmiHeader.biWidth=XSize;	
	HDC LocalDC=GetDC(hWnd);
	hb=CreateDIBitmap(LocalDC,&(lpbi->bmiHeader),CBM_INIT,buf,lpbi,DIB_RGB_COLORS);
	hb_exist=hb;//  
	ReleaseDC(hWnd,LocalDC);
	delete[] buf;
	if(IsLocalPalette)delete[] LocalPalette;
	delete[] Palette;

}



//////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                          //
//                                        JPEG                                              //
//                                                                                          //
//////////////////////////////////////////////////////////////////////////////////////////////


#define LOPART(x) ((x)&0xf)// 4   
#define HIPART(x) (((x)>>4)&15)// 4   

const UCHAR ZigZag[8][8]=		//    88   0..63  
					   {{0, 1, 5, 6,14,15,27,28},
						{2, 4, 7,13,16,26,29,42},
						{3, 8,12,17,25,30,41,43},
						{9,11,18,24,31,40,44,53},
					   {10,19,23,32,39,45,52,54},
					   {20,22,33,38,46,51,55,60},
					   {21,34,37,47,50,56,59,61},
					   {35,36,48,49,57,58,62,63}
};

typedef struct tagHuffmanTreeNode
	{
		signed char data;
		tagHuffmanTreeNode *left,*right;
	} 
	HUFFMANTREE;

//typedef UCHAR[][] QUANTUMTABLE;


template <class T> void rever(T& x)
{
	std::reverse((char*)&x,(char*)&x+sizeof(T));
}

typedef USHORT QTABLE[64];// .
typedef struct tagComponent
{
	UCHAR	Identifier,//  1-Y 2-Cb 3-Cr
			HorDiskr,//  
			VertDiskr,//  
			QTableNum;//  .
} COMPONENT;

typedef struct tagScanComponent
{
	UCHAR Selector;// 
	UCHAR Td;// D  
	UCHAR Ta;// AC  

} SCANCOMPONENT;

void DeleteTree(HUFFMANTREE* ht)//  :)
{
	if(ht->left)
	{
		if((ht->left->left==0)&&(ht->left->right==0))
		{
			delete ht->left;
			ht->left=0;
		}
		else
			DeleteTree(ht->left);
	}
	if(ht->right)
	{
		if((ht->right->left==0)&&(ht->right->right==0))
		{
			delete ht->right;
			ht->right=0;
		}
		else
			DeleteTree(ht->right);
	}

}
/////////////////
//  ,        
/////////////////
#define Pi 3.1415926535
FILE* f;
UCHAR CurByte=0;//  
UCHAR CurBit=8;//   
short DC[3];
bool not_end=true;
void ReadByte()
{
	fread(&CurByte,1,1,f);
	if(CurByte==0xFF)
	{
		while(CurByte==0xFF)//  0xff
		fread(&CurByte,1,1,f);
		if(CurByte==0)CurByte=0xFF;
		else
			if((CurByte>=0xD0)&&(CurByte<=0xD7))// 
			{
				DC[0]=DC[1]=DC[2]=0;
				ReadByte();
			}
			else 
				if(CurByte==0xD9)not_end=false;

	}
}

bool Read1Bit()
{
	if(CurBit==8)
	{
		ReadByte();
		CurBit=0;
	}
	return CurByte&(1<<(7-(CurBit++)));

}

void AddBit(long &l)//        l
{
	l<<=1;
	l+=Read1Bit();
}

long ReadBits(UCHAR NumBits)// NumBits   
{
	long l=0;
	for(UCHAR i=0;i<NumBits;i++)
		AddBit(l);
	return l;
}

void Invert(UCHAR NumBits,int& t)//    NumBits   
{
	int tt=1;
	for(UCHAR i=0;i<NumBits;i++)
	{
		t^=tt;
		tt<<=1;
	}
	t=-t;
}

UCHAR GetHuffCode(HUFFMANTREE* ht)//            ht  
{
	HUFFMANTREE* HuffPtr=ht;
	while((HuffPtr->left!=0)||(HuffPtr->right!=0))
	{
		if(HuffPtr==0)exit(-1);//  ,    
		if(Read1Bit())HuffPtr=HuffPtr->right;
		else HuffPtr=HuffPtr->left;//  1 ,     ,   .
	}
	//        ( ,     ),     ,          
	return HuffPtr->data;
}

void OpenJPEGFile(HWND hWnd)
{
		f=fopen(szFileName,"rb");
		// .
		double sqrt2=sqrt(2);
		UCHAR rc=0;
		//  .   -   FFNN  FF -   (  ,    ), NN - , () .   -  ,    ,    
		fread(&rc,1,1,f);
		if(rc!=0xFF) return;
		fread(&rc,1,1,f);
		if(rc!=0xD8)return;//   Jpeg'a ( BaseLine)   FFD8 (   .      - mm=motorola
	
		unsigned short SegmentSize=0;
		UCHAR BitsPerComp;//onent
		UCHAR planes;// - . (Y,Cb,Cr)>>?? :);
		UCHAR method;// ,   BaseLine  
		UCHAR HMax=0,VMax=0;//      

		short RstInterv=0;// .  RstInterv  MCU     .
		COMPONENT Components[4];//     -    (Y,Cb,Cr) - ,  AC  DC  . 
		HUFFMANTREE HTables[2][4];//() . AC  DC    4
		for(UCHAR a=0;a<2;a++)
			for(UCHAR b=0;b<4;b++)
			{
				HTables[a][b].left=0;
				HTables[a][b].right=0;
			}
		HUFFMANTREE* HuffPtr;//     .
		UCHAR NumTables=0;//-    .
		QTABLE QTables[4];// .
		UCHAR NumQTables=0;//-  

		//   ,   
		CurByte=0;//  
		CurBit=8;//   
		DC[2]=DC[1]=DC[0]=0;// DC
		not_end=true;
		
		
		
		do
		{
		fread(&rc,1,1,f);
		//  
		if(rc!=0xFF) return;
		fread(&rc,1,1,f);
		if(rc==0xD9)return;//     -  - :)
		fread(&SegmentSize,2,1,f);
		rever(SegmentSize);//    D8  D9   .

		switch(rc)
		{
		case 0xC0://!!SOF0  
		case 0xC1:
		case 0xC2:
		case 0xC3:
	
		case 0xC5:
		case 0xC6:
		case 0xC7:
		case 0xC8:
		case 0xC9:
		case 0xCA:
	
			{
			//  .    BaseLine    ,   ,     , ,        
			fread(&BitsPerComp,1,1,f);
			USHORT LocalXSize,LocalYSize;
			fread(&LocalYSize,2,1,f);
			rever(LocalYSize);
			YSize=LocalYSize;
			fread(&LocalXSize,2,1,f);
			rever(LocalXSize);
			XSize=LocalXSize;
			fread(&planes,1,1,f);
			
			if((BitsPerComp!=8)||(planes!=3))return;//only Baseline RGB jpegs are supported; :))
			
			method=rc;//     -  .  .
			
			for(UCHAR i=0;i<planes;i++)
			{
				fread(&Components[i].Identifier,1,1,f);
				fread(&rc,1,1,f);
				if(HMax<(Components[i].HorDiskr=HIPART(rc)))
					HMax=Components[i].HorDiskr;//  .
				if(VMax<(Components[i].VertDiskr=LOPART(rc)))
					VMax=Components[i].VertDiskr;
				fread(&Components[i].QTableNum,1,1,f);
			}
			
			break;
			}
		case 0xE0://,   JFIF (JFIF  )
			{
				char name[5];
				fread(name,5,1,f);
				for(UCHAR i=7;i<SegmentSize;i++)//7  5    ,  2  -  ,     .
					fread(&rc,1,1,f);
				break;
			}
		case 0xFE://
			{
				fseek(f,SegmentSize-2,SEEK_CUR);// 
				break;
			}
		case 0xC4://dht  
			{
				UCHAR Lengthes[16];//-    i+1
				unsigned short readed=2;
				UCHAR j=0;
				UCHAR NumTable;
				bool IsACTable;
				while(readed<SegmentSize)
				{
				fread(&rc,1,1,f);
				++readed;
				NumTable=rc&15;// 
				IsACTable=rc&16;//true -   , false  -  DC .
				//    ,  AC  DC  ,    .     AC    DC
				//   ...
				for(UCHAR i=0;i<16;i++)
					fread(&Lengthes[i],1,1,f);// -    _i+1_
				readed+=16;


				USHORT code=0,curcode=0;
	
				UCHAR depth=0;//   .== 
				bool bit;
				for(i=0;i<16;i++)//    i+1
				{
					for(j=0;j<Lengthes[i];j++)//      
					{
						fread(&rc,1,1,f);
						++readed;
						depth=0;
						curcode=code;
						curcode<<=sizeof(USHORT)*8-i-1;// 
						HuffPtr=&HTables[IsACTable][NumTable];
						while(depth<i+1)//       (       ,   =i+1   
						{
							bit=curcode&0x8000;//  .
							if(bit)//  - 1,  .
							{
								if(HuffPtr->right==0)//  ,  :)
								{
									HuffPtr->right=new HUFFMANTREE;
									HuffPtr=HuffPtr->right;
									HuffPtr->left=0;
									HuffPtr->right=0;
								}
								else
									HuffPtr=HuffPtr->right;
								
							}
							else//  =0,  :)
							{
								if(HuffPtr->left==0)//  ,  :)
								{
									HuffPtr->left=new HUFFMANTREE;
									HuffPtr=HuffPtr->left;
									HuffPtr->left=0;
									HuffPtr->right=0;
								}
								else
									HuffPtr=HuffPtr->left;
							}//end if(bit)
							++depth;
							curcode<<=1;//     (  ).
						}//end while(depth<
						HuffPtr->data=rc;
						++code;

					}//for(j
					code<<=1;//     
				}//for(i
				++NumTables;// -  () .
				}
				break;
			}
		case 0xDD:// 
			fread(&RstInterv,2,1,f);
			rever(RstInterv);// RstInterv  MCU ()     RSTn
			break;
		case 0xDB://qdt,  .
			{
				unsigned short readed=2,sc;//=2    2    

				while(readed<SegmentSize)
				{
					fread(&rc,1,1,f);
					++readed;
					UCHAR TableNum=rc&15;// 
					UCHAR Precision=0;// 
					if(rc>>4)Precision=1;//=0 - 8 bit, >0 - 16 bit
					for(UCHAR i=0;i<64;i++)
					{
						if(Precision)
						{
							fread(&sc,2,1,f);
							rever(sc);
							QTables[TableNum][i]=sc;
							readed+=2;
						}
						else
						{
							fread(&rc,1,1,f);
							QTables[TableNum][i]=rc;
							++readed;
						}
					}
						++NumQTables;
				}

			}
			break;
			case 0xDA: break;
		default:fseek(f,SegmentSize,SEEK_CUR);

		}//switch
		}//do
		while(rc!=0xDA);
		if(method!=0xC0)return;//  ,      ,     .
		//   (  ).
		
		SCANCOMPONENT ScanComponents[4];
		
		UCHAR NumComponents;
		fread(&NumComponents,1,1,f);// -    
		for(int i=0;i<NumComponents;i++)
		{
			fread(&(ScanComponents[i].Selector),1,1,f);
			fread(&rc,1,1,f);
			ScanComponents[i].Td=HIPART(rc);
			ScanComponents[i].Ta=LOPART(rc);
		}
		fseek(f,3,SEEK_CUR);

		// ,     .
		ULONG AdoptedLineSize=(XSize*3+3)/4*4;
			buf=new UCHAR[(AdoptedLineSize+1)*YSize+2];//        dWORD ,    BITMAP'a
	
		long XPos=0,YPos=0;//,        MCU (  )
		//,      Y, Cb  Cr
		UCHAR Y_Comp,Cb_Comp,Cr_Comp;
		for(i=0;i<planes;i++)
		{
			switch(Components[i].Identifier)
			{
			case 1: Y_Comp=i;break;
			case 2: Cb_Comp=i;break;
			case 3: Cr_Comp=i;break;
			}
		}
		//  MCU
		typedef short* LPSHORT;
		LPSHORT Fields[3];//   .    -   HorDiskr*VertDiskr
		for(i=0;i<3;i++)
			Fields[i]=new short[Components[i].HorDiskr*8*Components[i].VertDiskr*8];
		
//different variables,  used somewhere (placed here for optimization)
		UCHAR NumBits;
		UCHAR vecpos;
		int t;
		long EndX;
		long EndY;
		short vec_pos;//   ,   
		
	signed short tvector[64];// ,   .
	while(not_end)
	{
		USHORT CurComp=Y_Comp;//        Y 
		//  MCU

    for(UCHAR zz=0;zz<3;zz++)//    Y_Comp, Cb_Comp, Cr_Comp
	{
//,  ,   		DC=0;//   DC 
		for(i=0;i<Components[CurComp].VertDiskr;i++)//    Y   MCU
			for(UCHAR j=0;j<Components[CurComp].HorDiskr;j++)
			{
				//,     Y ( SOS)    Y ( SOF0) 
				NumBits=GetHuffCode(&HTables[0][ScanComponents[CurComp].Td]);// -   DC
				//   .
				if(NumBits)
				{
				t=ReadBits(NumBits);
				if((t&(1<<(NumBits-1)))==0)//    ==0,     ,       ,    
					Invert(NumBits,t);
				}
				else t=0;
				DC[zz]+=t;
				tvector[0]=DC[zz];
				vecpos=1;//    
				//  AC 
				while(vecpos<64)
				{
					NumBits=GetHuffCode(&HTables[1][ScanComponents[CurComp].Ta]);
					if(NumBits==0)//EOB    
					{
						memset(tvector+vecpos,0,(64-vecpos)*sizeof(tvector[1]));
						vecpos=64;
						break;
					}
					if(NumBits==0xF0)//  16 
					{
						memset(tvector+vecpos,0,16*sizeof(tvector[1]));
						vecpos+=16;
						continue;
					}
				
					memset(tvector+vecpos,0,HIPART(NumBits)*sizeof(tvector[1]));
					vecpos+=HIPART(NumBits);
					NumBits=NumBits&0xf;
					t=ReadBits(NumBits);
					
					if((t&(1<<(NumBits-1)))==0)//    ==0,     ,       ,    
						Invert(NumBits,t);

					tvector[vecpos++]=t;
				}//end while

				//,    
				for(UCHAR kk=0;kk<64;kk++)
				{
					tvector[kk]*=QTables[Components[CurComp].QTableNum][kk];//    tvector  QTables[i]     ,   -  .
				}
				//    
				float ft,tt;
				for(UCHAR y=0;y<8;y++)//1
					for(UCHAR x=0;x<8;x++)//2   ,     1  2,    ,   -    ,        ,  -     .
					{						/// , ..       ,     ,    ...   .
						ft=0;
						for(UCHAR u=0;u<8;u++)//3
							for(UCHAR v=0;v<8;v++)//4  3  4       ..   ..   ,  demo_s@ua.fm
							{
								tt=(float)tvector[ZigZag[v][u]/*u+8*v*/]*cos( (2*(float)x+1)/16*Pi*u )*cos(  (2*(float)y+1)/16*Pi*v );
								if(u==0) tt/=sqrt2;
								if(v==0) tt/=sqrt2;//       ,   , ft - ,    , tt - ,   ,       2.
								ft+=tt;
								
							}
						ft/=4;
						Fields[CurComp][(j+i*2)*64+x+8*y/*ZigZag[x][y]*/]=(short)ft+128;//    128   Y, Cb  Cr    (-128..127)->(0..255)
						//				^^^^^^    88    MCU   1 2 -  , 3 4 - .
					}
					
			}//end for

			//   
			if(CurComp==Y_Comp)CurComp=Cb_Comp;
			else
				if(CurComp==Cb_Comp)CurComp=Cr_Comp;
	}//end for(zz

	//  MCU,       .

//ULONG AALineSize=(XSize*3+3)/4)*4;

	UCHAR Y_Comp_XC=2/Components[Y_Comp].HorDiskr;//     ,  Y_Comp_XC=1, Y_Comp_YC=1,     2
	UCHAR Y_Comp_YC=2/Components[Y_Comp].VertDiskr;//        .    
	UCHAR Cb_Comp_XC=2/Components[Cb_Comp].HorDiskr;//  ()  Y = 2 ,   Cb  Cr = 1,    
	UCHAR Cb_Comp_YC=2/Components[Cb_Comp].VertDiskr;//  .   ,        1
	UCHAR Cr_Comp_XC=2/Components[Cr_Comp].HorDiskr;//    ,    -  22 - Y, 21 - Cb ,31 - Cr.
	UCHAR Cr_Comp_YC=2/Components[Cr_Comp].VertDiskr;//2x2     2     2.
												//    (       )    ,     ,      122YUV
												//      ,       :)   ,    .
	unsigned short tY;
	short tCb,tCr;
	short R,G,B;
	vec_pos=0;
	EndX=XPos+8*HMax;
	EndY=YPos+8*VMax;
	if((EndX>=XSize)&&(EndY>=YSize))not_end=false;
	if(EndX>XSize)EndX=XSize;//    ,     ,      ,       
							
	if(EndY>YSize)EndY=YSize;
	//  YYYYyyyyYYYYyyyy     BBBB  RRRR      1616
	long tEndY,tEndX;
	
	for(char ii=0;ii<HMax;ii++)
		for(char jj=0;jj<VMax;jj++)
		{
	//	vecpos=0;
		if((EndY-YPos-8-jj*8)>0)tEndY=YPos+8;
		else tEndY=EndY;
		if((EndX-XPos-8-ii*8)>0)tEndX=XPos+8;
		else tEndX=EndX;

	for(int j=YPos+jj*8;j<tEndY;j++)
	{
		for(int i=XPos+ii*8;i<tEndX;i++)
		{
			/*
			tY=Fields[Y_Comp][(i-XPos)/Y_Comp_XC+(j-YPos)/Y_Comp_YC*8];//i-XPos, j-YPos,         ,   Fields      ,  i<HMax, j<VMax. (   )
			tCb=Fields[Cb_Comp][(i-XPos)/Cb_Comp_XC+(j-YPos)/Cb_Comp_YC*8]-128;//!!  8*j/Cb_Comp_YC,   j/Cb_Comp_YC*8.  ,   14   15     7. 15/2=7   7*8=56  .  8*15/2=60,  ,   4!!
			tCr=Fields[Cr_Comp][(i-XPos)/Cr_Comp_XC+(j-YPos)/Cr_Comp_YC*8]-128;
			*/
			//                   VVVVVV         88 
			tY=Fields[Y_Comp][(i-XPos-ii*8)/Y_Comp_XC+(j-YPos-jj*8)/Y_Comp_YC*8+64*ii+128*jj];// ,         1.1.1  Y, Cb, Cr     .
								//  ,   122YUV    Y =4   64 .        1616
								//       4-   88           
							//(i-XPos-ii*8)/Y_Comp_XC+(j-YPos-jj*8)/Y_Comp_YC*8        88    1..64.
							//+64*ii+128*jj -        4-. 
			tCb=Fields[Cb_Comp][(i-XPos)/Cb_Comp_XC+(j-YPos)/Cb_Comp_YC*8]-128;//!!  8*j/Cb_Comp_YC,   j/Cb_Comp_YC*8.  ,   14   15     7. 15/2=7   7*8=56  .  8*15/2=60,  ,   4!!
			tCr=Fields[Cr_Comp][(i-XPos)/Cr_Comp_XC+(j-YPos)/Cr_Comp_YC*8]-128;//   88   .    1616 ,   88 ,       4 .
								//(i-XPos)/Cr_Comp_XC   Cr_Comp_XC  (     Cr_Comp_XC==2), .     D=1616 ,    B=88 . D(13,14)==B(6,7), 
			//Blue
			B=tY+1.772*tCb;
			//Green
			G=tY-0.34414*tCb-0.71414*tCr;
			//Red
			R=tY+1.402*tCr;
			if(R<0)R=0; else if(R>255)R=255;//    ..    ,     .
			if(G<0)G=0; else if(G>255)G=255;
			if(B<0)B=0; else if(B>255)B=255;
			buf[j*AdoptedLineSize+i*3]=B;
			buf[j*AdoptedLineSize+i*3+1]=G;
			buf[j*AdoptedLineSize+i*3+2]=R;
		
		}
		
	}
	
		}//end for
		//   MCU.
		if(EndX==XSize)
		{
			XPos=0;
			YPos=EndY;
		}
		else XPos=EndX;
	}//end while(not_end)

/*
    tCb=Cb-128       : :)..
R = [ Y + 1,402* (Cr - 128) ];
G = [ Y - 0,34414 *(Cb - 128) - 0,71414 *(Cr - 128) ];
B = [ Y + 1,772 *(Cb - 128) ];
if(R<0)R=0; else if(R>255)R=255;
if(G<0)G=0; else if(G>255)G=255;
if(B<0)B=0; else if(B>255)B=255;
*/
	
		// 
	if(hb_exist)
	{
		LocalFree(lpbi);
		DeleteObject(hb);
	}
	lpbi=(BITMAPINFO*)LocalAlloc(LPTR,sizeof(BITMAPINFOHEADER)+3);//
	
	/////////

	/////////
	lpbi->bmiHeader.biBitCount=24;//
	lpbi->bmiHeader.biClrImportant=0;//
	lpbi->bmiHeader.biClrUsed=0;//
	lpbi->bmiHeader.biCompression=BI_RGB;
	lpbi->bmiHeader.biHeight=-YSize;
	lpbi->bmiHeader.biPlanes=1;
	lpbi->bmiHeader.biSize=40;//sizeof(BITMAPINFOHEADER)
	lpbi->bmiHeader.biSizeImage=0;
	lpbi->bmiHeader.biWidth=XSize;	
	HDC LocalDC=GetDC(hWnd);
	hb=CreateDIBitmap(LocalDC,&(lpbi->bmiHeader),CBM_INIT,buf,lpbi,DIB_RGB_COLORS);
	hb_exist=hb;//  

	ReleaseDC(hWnd,LocalDC);

		delete[] buf;
		fclose(f);

	//   
	for(a=0;a<2;a++)
		for(char b=0;b<4;b++)
		{
			DeleteTree(&HTables[a][b]);
		}
	for(a=0;a<3;a++)
		delete Fields[a];
}

const UCHAR QuantTable[8][8]=	//   .(  88).  
{{16, 11, 10, 16, 24, 40, 51, 61},
 {12, 12, 14, 19, 26, 58, 60, 55},
 {14, 13, 16, 24, 40, 57, 69, 56},
 {14, 17, 22, 29, 51, 87, 80, 62},
 {18, 22, 37, 56, 68,109,103, 77},
 {24, 35, 55, 64, 81,104,113, 92},
 {49, 64, 78, 87,103,121,120,101},
 {72, 92, 95, 98,112,100,103, 99}};



bool SaveJPEGFile(HWND hWnd, PBITMAPINFO pBmpInfo)
{

	
	HANDLE hFile;
    LPBYTE lpBits;              /* memory pointer */
	DWORD NumColors=0;
	pBmpInfo->bmiHeader.biBitCount=24;

	
	HDC LocalDC=GetDC(hWnd);
	
	pBmpInfo->bmiHeader.biHeight=abs(pBmpInfo->bmiHeader.biHeight);

	if(!GetDIBits(LocalDC,hb,0,pBmpInfo->bmiHeader.biHeight,0,pBmpInfo,DIB_RGB_COLORS))//  
		return false;
	lpBits=new BYTE[pBmpInfo->bmiHeader.biSizeImage];//(LPBYTE)LocalAlloc(LPTR,pBmpInfo->bmiHeader.biSizeImage);
	if(!GetDIBits(LocalDC,hb,0,pBmpInfo->bmiHeader.biHeight,lpBits,pBmpInfo,DIB_RGB_COLORS))//  
		return false;
	
	
	//lets init structures;

	hFile=CreateFile(szFileName,GENERIC_WRITE,FILE_SHARE_READ,0,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,0);
	if(hFile==INVALID_HANDLE_VALUE) return false;//Error while opening the file
	DWORD res=0;
	//write fileheader
	UCHAR FF=0xFF;
	WriteFile(hFile,&FF,1,&res,0);
	UCHAR Marker=0xD8;
	WriteFile(hFile,&Marker,1,&res,0);
	
/*
		short Y= 0.299*R + 0.587*G + 0.114*B ;//
		short Cb=- 0.1687*R - 0.3313*G + 0.5*B + 128;
		short Cr=0.5*R - 0.4187*G - 0.0813*B + 128;
*/

	WriteFile(hFile,&FF,1,&res,0);
	Marker=0xD9;
	WriteFile(hFile,&Marker,1,&res,0);
	return CloseHandle(hFile);

}