// GraphConv.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "resource.h"
#include "SimpleForm.h"
#include "ComplForms.h"


#define MAX_LOADSTRING 100

// Global Variables:
HINSTANCE hInst;								// current instance
TCHAR szTitle[MAX_LOADSTRING];								// The title bar text
TCHAR szWindowClass[MAX_LOADSTRING];								// The title bar text

// Foward declarations of functions included in this code module:
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	About(HWND, UINT, WPARAM, LPARAM);




BITMAPINFO* lpbi;
int XSize;
int YSize;
HBITMAP hb;
bool hb_exist=false;
HWND hWnd;
char szFileName[MAX_PATH];
WORD extOffset;//    .


void SavePCXFile(HWND hWnd, LPBITMAPINFO lpBmp)
{}


void SaveTiffFile()
{}
 
int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
	
		
	// TODO: Place code here.
	MSG msg;
	HACCEL hAccelTable;


	// Initialize global strings
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_GRAPHCONV, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance);

	// Perform application initialization:
	if (!InitInstance (hInstance, nCmdShow)) 
	{
		return FALSE;
	}


	hAccelTable = LoadAccelerators(hInstance, (LPCTSTR)IDC_GRAPHCONV);

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg)) 
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return msg.wParam;
}



//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
//    This function and its usage is only necessary if you want this code
//    to be compatible with Win32 systems prior to the 'RegisterClassEx'
//    function that was added to Windows 95. It is important to call this function
//    so that the application will get 'well formed' small icons associated
//    with it.
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX); 

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= (WNDPROC)WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, (LPCTSTR)IDI_GRAPHCONV);
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= (LPCSTR)IDC_GRAPHCONV;
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, (LPCTSTR)IDI_SMALL);

	return RegisterClassEx(&wcex);
}

//
//   FUNCTION: InitInstance(HANDLE, int)
//
//   PURPOSE: Saves instance handle and creates main window
//
//   COMMENTS:
//
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{


   hInst = hInstance; // Store instance handle in our global variable

   hWnd = CreateWindow(szWindowClass, szTitle, WS_OVERLAPPEDWINDOW,
      CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, NULL, NULL, hInstance, NULL);

   if (!hWnd)
   {
      return FALSE;
   }

   ShowWindow(hWnd, nCmdShow);
   UpdateWindow(hWnd);

   return TRUE;
}



BOOL GetFileName(bool open, LPTSTR lpstrFile, int nFileMax, WORD& ExtOffset, DWORD& nFilterIndex)//open=true - open file, open=false - save file
{
	LPOPENFILENAME lpFileName=new OPENFILENAME;
	
	lpFileName->lStructSize=sizeof(OPENFILENAME);
	lpFileName->hwndOwner=hWnd;
	lpFileName->Flags=OFN_EXPLORER;
	if(open)
	lpFileName->Flags|=OFN_FILEMUSTEXIST|OFN_PATHMUSTEXIST;
	
	char* filter=new char[132];
	
	strcpy(filter,"PCX files");
	strcpy(filter+10,"*.pcx");
	strcpy(filter+16,"Windows bitmap (*.bmp)");
	strcpy(filter+39,"*.bmp");
	strcpy(filter+45,"TIFF files (*.tif),(*.tiff)");
	strcpy(filter+73,"*.tiff;*.tif");
	strcpy(filter+86,"24-bit bmp");
	strcpy(filter+97,"*.bmp");
	strcpy(filter+103,"GIF");
	strcpy(filter+107,"*.gif");
	strcpy(filter+113,"JPEG");
	strcpy(filter+118,"*.jpeg;*.jpg");
	filter[130]=0;
	filter[131]=0;
	
	lpFileName->lpstrFilter=filter;
	lpFileName->lpstrCustomFilter=0;
	lpFileName->nMaxCustFilter=0;
	
	if(open)
	lpFileName->nFilterIndex=1;
	else lpFileName->nFilterIndex=2;
	lpFileName->lpstrFile=lpstrFile;
	lpFileName->nMaxFile=nFileMax;

	lpFileName->lpstrFileTitle=0;
	lpFileName->nMaxFileTitle=0;

	char* lpstrDir=new char [MAX_PATH];
	GetCurrentDirectory(MAX_PATH,lpstrDir);
	lpFileName->lpstrInitialDir=lpstrDir;
	char* lpstrTitle=new char[40];
	if(open) strcpy(lpstrTitle,"Select file to open");
	else strcpy(lpstrTitle,"Save file as");

	lpFileName->lpstrTitle=lpstrTitle;
	lpFileName->nFileOffset=0;
	char* lpszDefExt=new char[4];
	if(open)
	strcpy(lpszDefExt,"pcx");
	else strcpy(lpszDefExt,"bmp");
	
	lpFileName->lpstrDefExt=0;//lpszDefExt;

	lpFileName->lpfnHook=0;
	lpFileName->lpTemplateName=0;
	lpFileName->lCustData=0;
	lpFileName->hInstance = (HINSTANCE)GetWindowLong(hWnd, GWL_HINSTANCE);
//	lpFileName->pvReserved=0;
//	lpFileName->dwReserved=0;
//	lpFileName->FlagsEx=0;
	BOOL res;
	if(open)
		res=GetOpenFileName(lpFileName);
	else 
		res=GetSaveFileName(lpFileName);
	ExtOffset=lpFileName->nFileExtension;
	nFilterIndex=lpFileName->nFilterIndex;
	delete[] lpszDefExt;
	delete[] lpstrDir;
	delete[] filter;
	return res;
}

//
//  FUNCTION: WndProc(HWND, unsigned, WORD, LONG)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	PAINTSTRUCT ps;
	HDC hdc;
	TCHAR szHello[MAX_LOADSTRING];
	LoadString(hInst, IDS_HELLO, szHello, MAX_LOADSTRING);

	switch (message) 
	{
		case WM_COMMAND:
			wmId    = LOWORD(wParam); 
			wmEvent = HIWORD(wParam); 
			// Parse the menu selections:
			switch (wmId)
			{
				case IDM_ABOUT:
				   DialogBox(hInst, (LPCTSTR)IDD_ABOUTBOX, hWnd, (DLGPROC)About);
				   break;
				case IDM_EXIT:
				   DestroyWindow(hWnd);
				   break;
				case IDM_FILE_OPEN:
					{
					//	OPENFILENAME OpenFile;
						DWORD nFilter;
						if(GetFileName(true,szFileName,MAX_PATH,extOffset,nFilter))
						{
						
						if(_stricmp(szFileName+extOffset,"pcx")==0)
						{OpenPCXFile(hWnd);}
						else
						if(_stricmp(szFileName+extOffset,"bmp")==0)
						{
							OpenBMPFile(hWnd);
						}
						else
						if((_stricmp(szFileName+extOffset,"tiff")==0)||(_stricmp(szFileName+extOffset,"tif")==0))
						{
							OpenTiffFile(hWnd);
						}
						else
							if(_stricmp(szFileName+extOffset,"gif")==0)
							{
								OpenGIFfile(hWnd);
							}
						else
							if((_stricmp(szFileName+extOffset,"jpeg")==0)||(_stricmp(szFileName+extOffset,"jpg")==0))
							{
								OpenJPEGFile(hWnd);
							}
						}
						/*
						switch(nFilter)
						{
						case 1://pcx
							OpenPCXFile(hWnd);
							break;
						case 2://bmp
						case 4:
							OpenBMPFile(hWnd);
							break;
						case 3://tif
							OpenTiffFile(hWnd);
							break;
						
						}
						*/
						InvalidateRect(hWnd,0,1);
					}
					SetWindowText(hWnd,szFileName);
					break;
				case IDM_FILE_SAVE:
					{
						DWORD nFilter;
						if(hb_exist)//  ,   .
						{
						if(GetFileName(false,szFileName,MAX_PATH,extOffset,nFilter))
						{
						
						if(_stricmp(szFileName+extOffset,"pcx")==0)
						{SavePCXFile(hWnd,lpbi);}
						if((_stricmp(szFileName+extOffset,"bmp")==0)||(nFilter==2)||(nFilter==4))
						{
							if(!extOffset) extOffset=strlen(szFileName)+1;
							strcpy(szFileName+extOffset-1,".bmp");
							if(nFilter==2)//  256 
							{
								lpbi->bmiHeader.biBitCount=8;
							}
							else//  16  
							{
								lpbi->bmiHeader.biBitCount=24;
							}
							SaveBMPFile(hWnd,lpbi);
						}
						if((_stricmp(szFileName+extOffset,"tiff")==0)||(_stricmp(szFileName+extOffset,"tif")))
						{
							SaveTiffFile();
						}
						}
						}
						/*
						switch(nFilter)
						{
						case 1://pcx
							SavePCXFile(hWnd,lpbi);
							break;
						case 2:
							lpbi->bmiHeader.biBitCount=8;
							SaveBMPFile(hWnd,lpbi);
							break;
						case 3:
							SaveTiffFile();
							break;
						case 4:
							lpbi->bmiHeader.biBitCount=24;
							SaveBMPFile(hWnd,lpbi);
							break;
						}
						*/
						
					}
					break;
				default:
				   return DefWindowProc(hWnd, message, wParam, lParam);
			}
			break;
		case WM_PAINT:
			{
			hdc = BeginPaint(hWnd, &ps);
			// TODO: Add any drawing code here...
			/*
			RECT rt;
			GetClientRect(hWnd, &rt);
			HDRAWDIB hdd=DrawDibOpen();
			DrawDibEnd(hdd);
			

					*/
			HDC hcdc=CreateCompatibleDC(hdc);

			HGDIOBJ OldObj=SelectObject(hcdc,hb);
			
			
			int res=BitBlt(hdc,0,0,XSize,YSize,hcdc,0,0,SRCCOPY);
			SelectObject(hcdc,OldObj);			
		
			
	
		//	HBITMAP hTmp=CreateDIBitmap(hdc,&(lpbi->bmiHeader),CBM_INIT,buf,lpbi,DIB_RGB_COLORS);
			
//			DeleteObject(hb);
			DeleteDC(hcdc);

			
			EndPaint(hWnd, &ps);
			}
			break;
	
		case WM_DESTROY:
			if(hb_exist)
			{
				LocalFree(lpbi);
				DeleteObject(hb);
			}
			PostQuitMessage(0);
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
   }
   return 0;
}

// Mesage handler for about box.
LRESULT CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
		case WM_INITDIALOG:
				return TRUE;

		case WM_COMMAND:
			if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL) 
			{
				EndDialog(hDlg, LOWORD(wParam));
				return TRUE;
			}
			break;
	}
    return FALSE;
}
